Number of unique ways that ATM can tender - 我的博客 - ITeye技术网站


Number of unique ways that ATM can tender - 我的博客 - ITeye技术网站
An atm can only dispense values of $1, $5, $20, and $50. Return the number
of unique ways that a $ amount of X can be tendered.
($1, $5) is distinct from ($5, $1)

Input: 4 Output: 1
Input: 6 Output: 3
Input: 100 Output: 954515231698
这题和Coin Change很像,只不过这题需要考虑顺序的问题。
Solution1:
用递归做。就像斐波那契数列那样。
  1. public int atm(int x) {  
  2.     if (x <= 0)  
  3.         return x == 0 ? 1 : 0;  
  4.      return atm(x - 1) + atm(x - 5) + atm(x - 20) + atm(x - 100);  
  5. }  
但是这样很多重复的计算,输入太大的话会栈溢出。所以我们可以考虑把中间结果保存起来。
  1. public long tellMoneyCombinations(int money) {  
  2.     long[] f = new long[money+1];  
  3.     f[0] = 1;  
  4.     for(int i=1; i<=money; i++) {  
  5.         f[i] = f[i-1];  
  6.         if(i>=5) f[i]+=f[i-5];  
  7.         if(i>=20) f[i]+=f[i-20];  
  8.         if(i>=50) f[i]+=f[i-50];  
  9.     }  
  10.     return f[money];  
  11. }  
http://yuanhsh.iteye.com/blog/2178328
Given a value N, if we want to make change for N cents, and we have infinite supply of each of S = { S1, S2, .. , Sm} valued coins, how many ways can we make the change? The order of coins doesn’t matter.
For example, for N = 4 and S = {1,2,3}, there are four solutions: {1,1,1,1},{1,1,2},{2,2},{1,3}. So output should be 4. For N = 10 and S = {2, 5, 3, 6}, there are five solutions: {2,2,2,2,2}, {2,2,3,3}, {2,2,6}, {2,3,5} and {5,5}. So the output should be 5.

We are trying to count the number of distinct sets.
Since order does not matter, we will impose that our solutions (sets) are all sorted in non-decreasing order (Thus, we are looking at sorted-set solutions: collections).
For a particular N and S=\{S_{1},S_{2},\ldots ,S_{m}\} (now with the restriction that S_{1}<S_{2}<\ldots <S_{m}, our solutions can be constructed in non-decreasing order), the set of solutions for this problem, C(N,m), can be partitioned into two sets:
  • There are those sets that do not contain any S_{m} and
  • Those sets that contain at least 1 S_{m}
If a solution does not contain S_{m}, then we can solve the subproblem of N with S=\{S_{1},S_{2},\ldots ,S_{{m-1}}\}, or the solutions of C(N,m-1).
If a solution does contain S_{m}, then we are using at least one S_{m}, thus we are now solving the subproblem of N-S_{m}S=\{S_{1},S_{2},\ldots ,S_{m}\}. This is C(N-S_{m},m).
Thus, we can formulate the following:
C(N,m)=C(N,m-1)+C(N-S_{m},m)
with the base cases:
  • C(N,m)=1,N=0 (one solution -- we have no money, exactly one way to solve the problem - by choosing no coin change, or, more precisely, to choose coin change of 0)
  • C(N,m)=0,N<0 (no solution -- negative sum of money)
  • C(N,m)=0,N\geq 1,m\leq 0 (no solution -- we have money, but no change available)
  1. public int coinChange(int[] S, int N) {  
  2.     int[] f = new int[N+1];  
  3.     f[0] = 1;  
  4.     for(int i=0; i<S.length; i++) {  
  5.         for(int j=S[i]; j<=N; j++) {  
  6.             f[j] += f[j-S[i]];  
  7.         }  
  8.     }  
  9.     return f[N];  
  10. }  

  1. // Returns the count of ways we can sum  S[0...m-1] coins to get sum n  
  2. int count( int S[], int m, int n ) {  
  3.     // If n is 0 then there is 1 solution (do not include any coin)  
  4.     if (n == 0)  
  5.         return 1;  
  6.        
  7.     // If n is less than 0 then no solution exists  
  8.     if (n < 0)  
  9.         return 0;  
  10.    
  11.     // If there are no coins and n is greater than 0, then no solution exist  
  12.     if (m <=0 && n >= 1)  
  13.         return 0;  
  14.    
  15.     // count is sum of solutions (i) including S[m-1] (ii) excluding S[m-1]  
  16.     return count( S, m - 1, n ) + count( S, m, n-S[m-1] );  

  1. int count( int S[], int m, int n )  
  2. {  
  3.     int i, j, x, y;  
  4.    
  5.     // We need n+1 rows as the table is consturcted in bottom up manner using   
  6.     // the base case 0 value case (n = 0)  
  7.     int table[n+1][m];  
  8.       
  9.     // Fill the enteries for 0 value case (n = 0)  
  10.     for (i=0; i<m; i++)  
  11.         table[0][i] = 1;  
  12.    
  13.     // Fill rest of the table enteries in bottom up manner    
  14.     for (i = 1; i < n+1; i++)  
  15.     {  
  16.         for (j = 0; j < m; j++)  
  17.         {  
  18.             // Count of solutions including S[j]  
  19.             x = (i-S[j] >= 0)? table[i - S[j]][j]: 0;  
  20.    
  21.             // Count of solutions excluding S[j]  
  22.             y = (j >= 1)? table[i][j-1]: 0;  
  23.    
  24.             // total count  
  25.             table[i][j] = x + y;  
  26.         }  
  27.     }  
  28.     return table[n][m-1];  
  29. }  
Time Complexity: O(mn)
Following is a simplified version of method 2. The auxiliary space required here is O(n) only.
  1. int count( int S[], int m, int n )  
  2. {  
  3.     // table[i] will be storing the number of solutions for  
  4.     // value i. We need n+1 rows as the table is consturcted  
  5.     // in bottom up manner using the base case (n = 0)  
  6.     int table[n+1];  
  7.    
  8.     // Initialize all table values as 0  
  9.     memset(table, 0, sizeof(table));  
  10.    
  11.     // Base case (If given value is 0)  
  12.     table[0] = 1;  
  13.    
  14.     // Pick all coins one by one and update the table[] values  
  15.     // after the index greater than or equal to the value of the  
  16.     // picked coin  
  17.     for(int i=0; i<m; i++)  
  18.         for(int j=S[i]; j<=n; j++)  
  19.             table[j] += table[j-S[i]];  
  20.    
  21.     return table[n];  
  22. }  
Read full article from Number of unique ways that ATM can tender - 我的博客 - ITeye技术网站

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts